/*********************************************************************
 *                
 * Copyright (C) 2002, 2005,  Karlsruhe University
 *                
 * File path:     kdb/kdb.h
 * Description:   
 *                
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *                
 * $Id: kdb.h,v 1.4.4.3 2005/05/17 10:56:07 skoglund Exp $
 *                
 ********************************************************************/
#ifndef __KDB__KDB_H__
#define __KDB__KDB_H__

class tcb_t;
class mdb_t;
class mdb_node_t;
class mdb_table_t;
class vrt_t;
class vrt_table_t;

#include <kdb/cmd.h>

class kdb_t {

public:
    cmd_mode_t	kdb_cmd_mode;
    void *	kdb_param;
    tcb_t *	kdb_current;


    friend class cmd_group_t;

// Allow autogenerated protos to be declared with static scope
#define STATIC static

#include <kdb_class_helper.h>
#include <kdb_autogenerated_protos.h>

#undef STATIC
#define STATIC
};


extern kdb_t kdb;


#endif /* !__KDB__KDB_H__ */
